/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2016-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
 *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
 *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
 *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
 *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
 *      スコード中に含まれていること．
 *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
 *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
 *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
 *      の無保証規定を掲載すること．
 *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
 *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
 *      と．
 *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
 *        作権表示，この利用条件および下記の無保証規定を掲載すること．
 *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
 *        報告すること．
 *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
 *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
 *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
 *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
 *      免責すること．
 * 
 *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
 *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
 *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
 *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
 *  の責任を負わない．
 * 
 *  @(#) $Id: device.h 698 2019-03-04 18:34:39Z roi $
 */
/*
 * 
 * 標準デバイス操作関数群の外部宣言
 *
 */

#ifndef _DEVICE_H_
#define _DEVICE_H_

#ifdef __cplusplus
 extern "C" {
#endif

#include "socfpga_cv.h"

/*
 *  TOPPERS BASE PLATFORM情報
 */
#define TOPPERS_BASE_PLATFORM_CV

/*
 *  バージョン情報
 */
#define	TPLATFORM_PRVER 0x1010		/* プラットフォームのバージョン番号 */

extern void device_init(intptr_t exinf);

/*
 * ピン設定
 */

#define PINPOSITION0    0
#define PINPOSITION1    1
#define PINPOSITION2    2
#define PINPOSITION3    3
#define PINPOSITION4    4
#define PINPOSITION5    5
#define PINPOSITION6    6
#define PINPOSITION7    7
#define PINPOSITION8    8
#define PINPOSITION9    9
#define PINPOSITION10   10
#define PINPOSITION11   11
#define PINPOSITION12   12
#define PINPOSITION13	13
#define PINPOSITION14	14
#define PINPOSITION15	15
#define PINPOSITION16	16
#define PINPOSITION17	17
#define PINPOSITION18	18
#define PINPOSITION19	19
#define PINPOSITION20	20
#define PINPOSITION21	21
#define PINPOSITION22	22
#define PINPOSITION23	23
#define PINPOSITION24	24
#define PINPOSITION25	25
#define PINPOSITION26	26
#define PINPOSITION27	27
#define PINPOSITION28	28
#define NUM_GPIOPIN     (PINPOSITION28+1)

#define GPIO_PIN_0      (1<<PINPOSITION0)
#define GPIO_PIN_1      (1<<PINPOSITION1)
#define GPIO_PIN_2      (1<<PINPOSITION2)
#define GPIO_PIN_3      (1<<PINPOSITION3)
#define GPIO_PIN_4      (1<<PINPOSITION4)
#define GPIO_PIN_5      (1<<PINPOSITION5)
#define GPIO_PIN_6      (1<<PINPOSITION6)
#define GPIO_PIN_7      (1<<PINPOSITION7)
#define GPIO_PIN_8      (1<<PINPOSITION8)
#define GPIO_PIN_9      (1<<PINPOSITION9)
#define GPIO_PIN_10     (1<<PINPOSITION10)
#define GPIO_PIN_11     (1<<PINPOSITION11)
#define GPIO_PIN_12     (1<<PINPOSITION12)
#define GPIO_PIN_13     (1<<PINPOSITION13)
#define GPIO_PIN_14     (1<<PINPOSITION14)
#define GPIO_PIN_15     (1<<PINPOSITION15)
#define GPIO_PIN_16     (1<<PINPOSITION16)
#define GPIO_PIN_17     (1<<PINPOSITION17)
#define GPIO_PIN_18     (1<<PINPOSITION18)
#define GPIO_PIN_19     (1<<PINPOSITION19)
#define GPIO_PIN_20     (1<<PINPOSITION20)
#define GPIO_PIN_21     (1<<PINPOSITION21)
#define GPIO_PIN_22     (1<<PINPOSITION22)
#define GPIO_PIN_23     (1<<PINPOSITION23)
#define GPIO_PIN_24     (1<<PINPOSITION24)
#define GPIO_PIN_25     (1<<PINPOSITION25)
#define GPIO_PIN_26     (1<<PINPOSITION26)
#define GPIO_PIN_27     (1<<PINPOSITION27)
#define GPIO_PIN_28     (1<<PINPOSITION28)

/*
 *  GPIOモードパラメータ
 */
#define GPIO_MODE_INPUT     0x00000000	/* Input Floating Mode */
#define GPIO_MODE_OUTPUT    0x00000001	/* Output Mode */
#define GPIO_MODE_AF        0x00000002	/* Alternate Function Mode */
#define GPIO_MODE_ANALOG    0x00000003	/* Analog Mode  */

/*
 *  GPIO-EXTIモードパラメータ
 */
#define GPIO_MODE_IT_FALLING            0x10010000	/* Interrupt Mode with Falling edge trigger detection */
#define GPIO_MODE_IT_RISING             0x10110000	/* Interrupt Mode with Rising edge trigger detection */
#define GPIO_MODE_IT_RISING_FALLING     0x10210000	/* Interrupt Mode with Rising/Falling edge trigger detection */
#define GPIO_MODE_LEVEL_LOW             0x10000000	/* Interrupt Mode with Level Low */
#define GPIO_MODE_LEVEL_HIGH            0x10100000	/* Interrupt Mode with Level High */

/*
 *  DEBONCEパラメータ
 */
#define GPIO_NODEBOUNCE     0x00000000	/* debounce off */
#define GPIO_DEBOUNCE       0x00000001	/* debounce on  */


/*
 *  GPIO初期化設定
 */
typedef struct
{
    uint32_t    mode;		/* specifies the operating mode for the selected pins. */
	uint32_t    debounce;	/* debounce select */
	uint32_t    data;		/* initial data */
}GPIO_Init_t;

typedef struct {
	uint32_t    base;
	uint32_t    pinmap;
} GPIO_Init_Table;

#define INHNO_GIO0  (0x00010000 | INTNO_GPIO0)	/* 割込みハンドラ番号 */
#define INTNO_GIO0  INTNO_GPIO0	/* 割込み番号 */
#define INTPRI_GIO0 -10			/* 割込み優先度 */
#define INTATR_GIO0 TA_EDGE		/* 割込み属性 */

#define INHNO_GIO1  (0x00010000 | INTNO_GPIO1)	/* 割込みハンドラ番号 */
#define INTNO_GIO1  INTNO_GPIO1	/* 割込み番号 */
#define INTPRI_GIO1 -10			/* 割込み優先度 */
#define INTATR_GIO1 TA_EDGE		/* 割込み属性 */

#define INHNO_GIO2  (0x00010000 | INTNO_GPIO2)	/* 割込みハンドラ番号 */
#define INTNO_GIO2  INTNO_GPIO2	/* 割込み番号 */
#define INTPRI_GIO2 -10			/* 割込み優先度 */
#define INTATR_GIO2 TA_EDGE		/* 割込み属性 */

extern void gpio_setup(uint32_t base, GPIO_Init_t *init, uint32_t pin);
extern void gpio_dev_isr(intptr_t exinf);
extern void (*gpioi_func[][NUM_GPIOPIN])(void);


/*
 *  キャッシュ制御関数
 */
#define CACHE_LINE_SIZE	    32	/* A9 cacle line size */

extern void invalidatedcache_by_addr(uint8_t *addr, int32_t dsize);
extern void flushdcache_by_addr(uint8_t *addr, int32_t dsize);
extern void flushinvalidatedcache_by_addr(uint8_t *addr, int32_t dsize);


/*
 *  L4 WATCH-DOGドライバ
 */
#define WDOG1_PORTID        1
#define WDOG2_PORTID        2
#define NUM_WDOGPORT        2

#define WDOG_TIMEOUT2G     15

extern ER wdog_init(ID portid);
extern ER wdog_deinit(ID portid);
extern ER wdog_start(ID portid, uint8_t regtim, uint8_t initim);
extern ER wdog_stop(ID portid);
extern ER wdog_reset(ID portid);


/*
 *  DMA ペリフェラル定義
 */
#define DMA_PERIPH_FPGA_0               0	/* FPGA soft IP interface 0 */
#define DMA_PERIPH_FPGA_1               1	/* FPGA soft IP interface 1 */
#define DMA_PERIPH_FPGA_2               2	/* FPGA soft IP interface 2 */
#define DMA_PERIPH_FPGA_3               3	/* FPGA soft IP interface 3 */
#define DMA_PERIPH_FPGA_4_OR_CAN0_IF1	4	/* Selectively MUXed FPGA 4 or CAN 0 interface 1 */
#define DMA_PERIPH_FPGA_5_OR_CAN0_IF2   5	/* Selectively MUXed FPGA 5 or CAN 0 interface 2 */
#define DMA_PERIPH_FPGA_6_OR_CAN1_IF1   6	/* Selectively MUXed FPGA 6 or CAN 1 interface 1 */
#define DMA_PERIPH_FPGA_7_OR_CAN1_IF2   7	/* Selectively MUXed FPGA 7 or CAN 1 interface 2 */
#define DMA_PERIPH_FPGA_4               DMA_PERIPH_FPGA_4_OR_CAN0_IF1
#define DMA_PERIPH_FPGA_5               DMA_PERIPH_FPGA_5_OR_CAN0_IF2
#define DMA_PERIPH_FPGA_6               DMA_PERIPH_FPGA_6_OR_CAN1_IF1
#define DMA_PERIPH_FPGA_7               DMA_PERIPH_FPGA_7_OR_CAN1_IF2
#define DMA_PERIPH_CAN0_IF1             DMA_PERIPH_FPGA_4_OR_CAN0_IF1
#define DMA_PERIPH_CAN0_IF2             DMA_PERIPH_FPGA_5_OR_CAN0_IF2
#define DMA_PERIPH_CAN1_IF1             DMA_PERIPH_FPGA_6_OR_CAN1_IF1
#define DMA_PERIPH_CAN1_IF2             DMA_PERIPH_FPGA_7_OR_CAN1_IF2
#define DMA_PERIPH_I2C0_TX              8	/* I2C 0 TX */
#define DMA_PERIPH_I2C0_RX              9	/* I2C 0 RX */
#define DMA_PERIPH_I2C1_TX              10	/* I2C 1 TX */
#define DMA_PERIPH_I2C1_RX              11	/* I2C 1 RX */
#define DMA_PERIPH_I2C2_TX              12	/* I2C 2 TX */
#define DMA_PERIPH_I2C2_RX              13	/* I2C 2 RX */
#define DMA_PERIPH_I2C3_TX              14	/* I2C 3 TX */
#define DMA_PERIPH_I2C3_RX              15	/* I2C 3 RX */
#define DMA_PERIPH_SPI0_MASTER_TX       16	/* SPI 0 Master TX */
#define DMA_PERIPH_SPI0_MASTER_RX       17	/* SPI 0 Master RX */
#define DMA_PERIPH_SPI0_SLAVE_TX        18	/* SPI 0 Slave TX */
#define DMA_PERIPH_SPI0_SLAVE_RX        19	/* SPI 0 Slave RX */
#define DMA_PERIPH_SPI1_MASTER_TX       20	/* SPI 1 Master TX */
#define DMA_PERIPH_SPI1_MASTER_RX       21	/* SPI 1 Master RX */
#define DMA_PERIPH_SPI1_SLAVE_TX        22	/* SPI 1 Slave TX */
#define DMA_PERIPH_SPI1_SLAVE_RX        23	/* SPI 1 Slave RX */
#define DMA_PERIPH_QSPI_FLASH_TX        24	/* QSPI Flash TX */
#define DMA_PERIPH_QSPI_FLASH_RX        25	/* QSPI Flash RX */
#define DMA_PERIPH_STM                  26	/* System Trace Macrocell */
#define DMA_PERIPH_UART0_TX             28	/* UART 0 TX */
#define DMA_PERIPH_UART0_RX             29	/* UART 0 RX */
#define DMA_PERIPH_UART1_TX             30	/* UART 1 TX */
#define DMA_PERIPH_UART1_RX             31	/* UART 1 RX */

/*
 *  DMAチャネルID定義
 */
#define DMAC1_CHANNELID         1
#define DMAC2_CHANNELID         2
#define DMAC3_CHANNELID         3
#define DMAC4_CHANNELID         4
#define DMAC5_CHANNELID         5
#define DMAC6_CHANNELID         6
#define DMAC7_CHANNELID         7
#define DMAC8_CHANNELID         8
#define NUM_DMACHANNEL          8

/*
 *  DMAイベント定義
 */
#define DMA_EVENT_0             0	/* DMA Event 0 */
#define DMA_EVENT_1             1	/* DMA Event 1 */
#define DMA_EVENT_2             2	/* DMA Event 2 */
#define DMA_EVENT_3             3	/* DMA Event 3 */
#define DMA_EVENT_4             4	/* DMA Event 4 */
#define DMA_EVENT_5             5	/* DMA Event 5 */
#define DMA_EVENT_6             6	/* DMA Event 6 */
#define DMA_EVENT_7             7	/* DMA Event 7 */
#define DMA_EVENT_ABORT         8	/* DMA Abort Event */

/*
 *  DMA SECURITY状態定義
 */
#define DMA_SECURITY_DEFAULT    0	/* Use the default security value (e.g. reset default) */
#define DMA_SECURITY_SECURE     1	/* Secure */
#define DMA_SECURITY_NONSECURE  2	/* Non-secure */

/*
 *  DMA イベント要求定義
 */
#define DMA_EVENT_NONE          0
#define DMA_EVENT_REQ           1
#define DMA_EVENT_INTREQ        2

/*
 *  DMAエラー定義
 */
#define DMA_ERROR_NONE          0x00000000		/* No error              */
#define DMA_ERROR_CH_UNDEFINST  0x00000001		/* チャネル・インストラクション未定義 */
#define DMA_ERROR_CH_OPEINVALID 0x00000002		/* チャネル・オペランド不良 */
#define DMA_ERROR_CH_EVTERR     0x00000004		/* チャネル・イベントエラー */
#define DMA_ERROR_CH_PERIPHERR  0x00000008		/* チャネル・ペリフェラルエラー */
#define DMA_ERROR_CH_RDWRERR    0x00000010		/* チャネル・READ/WRITEエラー */
#define DMA_ERROR_CH_MFIFOERR   0x00000020		/* チャネル・MFIFOエラー */
#define DMA_ERROR_CH_DATAUNAVAL 0x00000040		/* チャネル・データアベーラベルエラー */
#define DMA_ERROR_CH_INSTFETERR 0x00000080		/* チャネル・インストラクション・フェッチエラー */
#define DMA_ERROR_CH_DWRITEERR  0x00000100		/* チャネル・データWRITEエラー */
#define DMA_ERROR_CH_DREADERR   0x00000200		/* チャネル・データREADエラー */
#define DMA_ERROR_CH_DBGINST    0x00001000		/* チャネル・デバッグインストラクションエラー */
#define DMA_ERROR_CH_LOCKUPERR  0x00002000		/* チャネル・ロックアップエラー */
#define DMA_ERROR_MG_UNDEFINST  0x00010000		/* マネージャー・インストラクション未定義 */
#define DMA_ERROR_MG_OPEINVALID 0x00020000		/* マネージャー・オペランド不良 */
#define DMA_ERROR_MG_DMAGOERR   0x00040000		/* マネージャー・DMAGOエラー */
#define DMA_ERROR_MG_EVNTERR    0x00080000		/* マネージャー・パーミッションエラー */
#define DMA_ERROR_MG_INSTFETERR 0x00800000		/* マネージャー・インストラクション・フェッチエラー */
#define DMA_ERROR_MG_DBGINST    0x01000000		/* マネージャー・デバッグインストラクションエラー */

/*
 *  DMA CHANNEL STATE定義
 */
#define DMACH_STATE_STOPPED     0	/* Stopped */
#define DMACH_STATE_EXECUTING   1	/* Executing */
#define DMACH_STATE_CACHE_MISS  2	/* Cache Miss */
#define DMACH_STATE_UPDATING_PC 3	/* Updating PC */
#define DMACH_STATE_WFE         4	/* Waiting for Event */
#define DMACH_STATE_AT_BARRIER  5	/* At Barrier */
#define DMACH_STATE_WFP         7	/* Waiting for Peripheral */
#define DMACH_STATE_KILLING     8	/* Killing */
#define DMACH_STATE_COMPLETING  9	/* Completing */
#define DMACH_STATE_FAULTING_COMPLETING 14	/* Faulting Completing */
#define DMACH_STATE_FAULTING    15	/* Faulting */

/*
 *  DMAプログラム・レジスタ定義
 */
#define DMA_PROGRAM_REG_SAR     0	/* Source Address Register */
#define DMA_PROGRAM_REG_CCR     1	/* Channel Control Register */
#define DMA_PROGRAM_REG_DAR     2	/* Destination Address Register */

/*
 *  DMAプログラム・インストラクション・モード
 */
#define DMA_PROGRAM_INST_MOD_NONE   0
#define DMA_PROGRAM_INST_MOD_SINGLE 1	/* シングル・モード */
#define DMA_PROGRAM_INST_MOD_PERIPH 2	/* ペリフェラル・モード */
#define DMA_PROGRAM_INST_MOD_BURST  3	/* ブースト・モード */

/*
 * DMAプログラム・インストラクション設定
 */
#define DMA_PROGRAM_INST_LD     0x04	/* DMALD */
#define DMA_PROGRAM_INST_ST     0x08	/* DMAST */
#define DMA_PROGRAM_INST_STZ    0x0C	/* DMASTZ */

/*
 *  DMAソースアドレス指定
 */
#define DMA_CCR_OPT_SAF         0x00000000	/* Source Address Fixed address burst */
#define DMA_CCR_OPT_SAI         0x00000001	/* Source Address Incrementing address burst */

/*
 *  DMA ソースバーストサイズ
 */
#define DMA_CCR_OPT_SS8         0x00000000	/* Source burst Size of 8 bits */
#define DMA_CCR_OPT_SS16        0x00000002	/* Source burst Size of 16 bits */
#define DMA_CCR_OPT_SS32        0x00000004	/* Source burst Size of 32 bits */
#define DMA_CCR_OPT_SS64        0x00000006	/* Source burst Size of 64 bits */
#define DMA_CCR_OPT_SS128       0x00000008	/* Source burst Size of 128 bits */

/*
 *  DMAソースバーストレングス
 */
#define DMA_CCR_OPT_SB1         0x00000000	/* Source Burst length of 1 transfer */
#define DMA_CCR_OPT_SB2         0x00000010	/* Source Burst length of 2 transfers */
#define DMA_CCR_OPT_SB3         0x00000020	/* Source Burst length of 3 transfers */
#define DMA_CCR_OPT_SB4         0x00000030	/* Source Burst length of 4 transfers */
#define DMA_CCR_OPT_SB5         0x00000040	/* Source Burst length of 5 transfers */
#define DMA_CCR_OPT_SB6         0x00000050	/* Source Burst length of 6 transfers */
#define DMA_CCR_OPT_SB7         0x00000060	/* Source Burst length of 7 transfers */
#define DMA_CCR_OPT_SB8         0x00000070	/* Source Burst length of 8 transfers */
#define DMA_CCR_OPT_SB9         0x00000080	/* Source Burst length of 9 transfers */
#define DMA_CCR_OPT_SB10        0x00000090	/* Source Burst length of 10 transfers */
#define DMA_CCR_OPT_SB11        0x000000a0	/* Source Burst length of 11 transfers */
#define DMA_CCR_OPT_SB12        0x000000b0	/* Source Burst length of 12 transfers */
#define DMA_CCR_OPT_SB13        0x000000c0	/* Source Burst length of 13 transfers */
#define DMA_CCR_OPT_SB14        0x000000d0	/* Source Burst length of 14 transfers */
#define DMA_CCR_OPT_SB15        0x000000e0	/* Source Burst length of 15 transfers */
#define DMA_CCR_OPT_SB16        0x000000f0	/* Source Burst length of 16 transfers */

/*
 *  DMAソースプロテクション
 */
#define DMA_CCR_OPT_SP(imm3)    ((imm3) << 8)	/* Source Protection bits for AXI bus ARPROT[2:0] */

/*
 *  DMAソースキャッシュ
 */
#define DMA_CCR_OPT_SC(imm4)    ((imm4) << 11)	/* Source Cache bits for AXI bus ARCACHE[2:0] */

/*
 *  DMAディスティネーションアドレス指定
 */
#define DMA_CCR_OPT_DAF         0x00000000	/* Destination Address Fixed address burst */
#define DMA_CCR_OPT_DAI         0x00004000	/* Destination Address Incrementing address burst */

/*
 *  DMAディスティネーションバーストサイズ
 */
#define DMA_CCR_OPT_DS8         0x00000000	/* Destination burst Size of 8 bits */
#define DMA_CCR_OPT_DS16        0x00008000	/* Destination burst Size of 16 bits */
#define DMA_CCR_OPT_DS32        0x00010000	/* Destination burst Size of 32 bits */
#define DMA_CCR_OPT_DS64        0x00018000	/* Destination burst Size of 64 bits */
#define DMA_CCR_OPT_DS128       0x00020000	/* Destination burst Size of 128 bits */

/*
 *  DMAディスティネーションバーストレングス
 */
#define DMA_CCR_OPT_DB1         0x00000000	/* Destination Burst length of 1 transfer */
#define DMA_CCR_OPT_DB2         0x00040000	/* Destination Burst length of 2 transfers */
#define DMA_CCR_OPT_DB3         0x00080000	/* Destination Burst length of 3 transfers */
#define DMA_CCR_OPT_DB4         0x000C0000	/* Destination Burst length of 4 transfers */
#define DMA_CCR_OPT_DB5         0x00100000	/* Destination Burst length of 5 transfers */
#define DMA_CCR_OPT_DB6         0x00140000	/* Destination Burst length of 6 transfers */
#define DMA_CCR_OPT_DB7         0x00180000	/* Destination Burst length of 7 transfers */
#define DMA_CCR_OPT_DB8         0x001C0000	/* Destination Burst length of 8 transfers */
#define DMA_CCR_OPT_DB9         0x00200000	/* Destination Burst length of 9 transfers */
#define DMA_CCR_OPT_DB10        0x00240000	/* Destination Burst length of 10 transfers */
#define DMA_CCR_OPT_DB11        0x00280000	/* Destination Burst length of 11 transfers */
#define DMA_CCR_OPT_DB12        0x002C0000	/* Destination Burst length of 12 transfers */
#define DMA_CCR_OPT_DB13        0x00300000	/* Destination Burst length of 13 transfers */
#define DMA_CCR_OPT_DB14        0x00340000	/* Destination Burst length of 14 transfers */
#define DMA_CCR_OPT_DB15        0x00380000	/* Destination Burst length of 15 transfers */
#define DMA_CCR_OPT_DB16        0x003C0000	/* Destination Burst length of 16 transfers */

/*
 *  DMAディスティネーションプロテクション
 */
#define DMA_CCR_OPT_DP(imm3)    ((imm3) << 22)	/* Destination Protection bits for AXI bus AWPROT[2:0] */

/*
 *  DMAディスティネーションキャッシュ
 */
#define DMA_CCR_OPT_DC(imm4)    ((imm4) << 25)	/* Destination Cache bits for AXI bus AWCACHE[3,1:0] */

/*
 *  DMAエンディアンスワップサイズ
 */
#define DMA_CCR_OPT_ES8         0x00000000	/* Endian Swap: No swap, 8-bit data */
#define DMA_CCR_OPT_ES16        0x10000000	/* Endian Swap: Swap bytes within 16-bit data */
#define DMA_CCR_OPT_ES32        0x20000000	/* Endian Swap: Swap bytes within 32-bit data */
#define DMA_CCR_OPT_ES64        0x30000000	/* Endian Swap: Swap bytes within 64-bit data */

#ifndef DMA_PROGRAM_CACHE_LINE_COUNT
#define DMA_PROGRAM_CACHE_LINE_COUNT        (16)
#endif

#define DMA_PROGRAM_PROVISION_BUFFER_SIZE   (DMA_PROGRAM_CACHE_LINE_COUNT * CACHE_LINE_SIZE)

/*
 *  DMAチャネル・ハンドラ定義
 */
typedef struct DMACH_Handle DMACH_Handle_t;
struct DMACH_Handle
{
	uint8_t     dmach_id;					/* DMAチャネルID(1-8) */
	uint8_t     periph_info;				/* ペリフェラル番号(0-31) */
	uint8_t     periph_can;					/* CAN/FPGA選択 */
	uint8_t     periph_sec;					/* セキュア設定 */
	uint8_t     irq_sec;					/* 割込みセキュア設定 */
	uint8_t     evt_req;					/* イベント選択 */
	uint8_t     event;						/* イベントID */
	uint8_t     dummy;						/* リザーブ領域 */
	void        *phandle;					/* ペリフェラルのハンドラへのポインタ */
	uint8_t     *pbuff;						/* 転送メモリアドレス */
	uint32_t    xfersize;					/* 転送データサイズ */
	uint32_t    xfercount;					/* 転送データカウント */
	uint32_t    errorcode;					/* DMAエラーコード */

	ER          (*dma_start)(DMACH_Handle_t *hdmach);	/* 転送設定コールバック関数 */
	void        (*dma_end)(DMACH_Handle_t *hdmach);	/* 転送終了コールバック関数 */

	uint16_t    flag;						/* DMA PROGRAMフラグ */
	uint16_t    code_size;					/* DMA PROGRAMサイズ */

	uint16_t    loop0;						/* loop count0 */
	uint16_t    loop1;						/* loop count1 */
	uint16_t    sar;
	uint16_t    dar;
	uint8_t     *program;					/* DMA PROGRAM領域ポインタ */

    /*
     *  DMAプログラミング領域
     */
	uint8_t     buffer[DMA_PROGRAM_PROVISION_BUFFER_SIZE + CACHE_LINE_SIZE];
};

#define INHNO_DMA1  (0x00010000 | INTNO_DMA_IRQ0)	/* 割込みハンドラ番号 */
#define INTNO_DMA1  INTNO_DMA_IRQ0	/* 割込み番号 */
#define INTPRI_DMA1 -10			/* 割込み優先度 */
#define INTATR_DMA1 0			/* 割込み属性 */

#define INHNO_DMA2  (0x00010000 | INTNO_DMA_IRQ1)	/* 割込みハンドラ番号 */
#define INTNO_DMA2  INTNO_DMA_IRQ1	/* 割込み番号 */
#define INTPRI_DMA2 -10			/* 割込み優先度 */
#define INTATR_DMA2 0			/* 割込み属性 */

#define INHNO_DMA3  (0x00010000 | INTNO_DMA_IRQ2)	/* 割込みハンドラ番号 */
#define INTNO_DMA3  INTNO_DMA_IRQ2	/* 割込み番号 */
#define INTPRI_DMA3 -10			/* 割込み優先度 */
#define INTATR_DMA3 0			/* 割込み属性 */

#define INHNO_DMA4  (0x00010000 | INTNO_DMA_IRQ3)	/* 割込みハンドラ番号 */
#define INTNO_DMA4  INTNO_DMA_IRQ3	/* 割込み番号 */
#define INTPRI_DMA4 -10			/* 割込み優先度 */
#define INTATR_DMA4 0			/* 割込み属性 */

#define INHNO_DMA5  (0x00010000 | INTNO_DMA_IRQ4)	/* 割込みハンドラ番号 */
#define INTNO_DMA5  INTNO_DMA_IRQ4	/* 割込み番号 */
#define INTPRI_DMA5 -10			/* 割込み優先度 */
#define INTATR_DMA5 0			/* 割込み属性 */

#define INHNO_DMA6  (0x00010000 | INTNO_DMA_IRQ5)	/* 割込みハンドラ番号 */
#define INTNO_DMA6  INTNO_DMA_IRQ5	/* 割込み番号 */
#define INTPRI_DMA6 -10			/* 割込み優先度 */
#define INTATR_DMA6 0			/* 割込み属性 */

#define INHNO_DMA7  (0x00010000 | INTNO_DMA_IRQ6)	/* 割込みハンドラ番号 */
#define INTNO_DMA7  INTNO_DMA_IRQ6	/* 割込み番号 */
#define INTPRI_DMA7 -10			/* 割込み優先度 */
#define INTATR_DMA7 0			/* 割込み属性 */

#define INHNO_DMA8  (0x00010000 | INTNO_DMA_IRQ7)	/* 割込みハンドラ番号 */
#define INTNO_DMA8  INTNO_DMA_IRQ7	/* 割込み番号 */
#define INTPRI_DMA8 -10			/* 割込み優先度 */
#define INTATR_DMA8 0			/* 割込み属性 */

extern void dma_init(intptr_t exinf);
extern void dma_deinit(void);
extern ER dma_channel_open(ID channelid, DMACH_Handle_t *hdmach);
extern ER dma_channel_close(DMACH_Handle_t *hdmach);
extern ER dma_periph_transfer(DMACH_Handle_t *hdmach, void * addr, uint32_t size);
extern ER dma_memory_to_memory(DMACH_Handle_t *hdmach, void * dst, void * src, uint32_t size);
extern ER dma_zero_to_memory(DMACH_Handle_t *hdmach, void * buf, uint32_t size);
extern ER dma_channel_exec(DMACH_Handle_t *hdmach);
extern ER_UINT dma_channel_state(DMACH_Handle_t *hdmach);
extern void dma_hps_isr(intptr_t exinf);

extern ER dma_program_start(DMACH_Handle_t *hdmach);
extern ER dma_program_move(DMACH_Handle_t *hdmach, uint8_t chan_reg, uint32_t val);
extern ER dma_program_mode(DMACH_Handle_t *hdmach, uint8_t mode,  uint8_t inst);
extern ER dma_program_lpstart(DMACH_Handle_t *hdmach, uint32_t iterations);
extern ER dma_program_lpend(DMACH_Handle_t *hdmach, uint8_t mode, uint32_t iterations);
extern ER dma_program_periph(DMACH_Handle_t *hdmach, uint8_t mode, bool_t in);
extern ER dma_program_end(DMACH_Handle_t *hdmach, bool_t wmb);


/*
 * LED接続ビット
 */
#define LED01           (1<<PINPOSITION24)
#define LED02           0
#define LED03           0
#define LED04           0

#define LED_MASK        (LED01 | LED02 | LED03 | LED04)

/*
 * LEDとスイッチの状態マクロ
 */
#define ON              1     /* LEDやスイッチON状態             */
#define OFF             0     /* LEDやスイッチOFF状態            */

/*
 * DIPSW設定
 */
#define DSW1             0x01
#define DSW2             0x02
#define DSW3             0x04
#define DSW4             0x08

/*
 *  LED接続ポート初期化
 */ 
extern void led_init(intptr_t exinf);

/*
 *  LED接続ポート読み出し
 */
uint_t led_in(void);

/*
 *  LED接続ポート書き込み
 */ 
void led_out(unsigned int led_data);

/*
 * LEDとスイッチの個別設定・読み込み関数群
 */
extern void set_led_state(unsigned short led, unsigned char state);


/*
 * PSW接続ビット
 */
#define PSW1             0x00000001
#define PSW_MASK         (PSW1)
#define PSW_CHK_INTERVAL 10


/*
 * PUSHスイッチ接続ポート初期化
 */
extern void switch_push_init(intptr_t exinf);


/*
 * PUSHスイッチ割込みクリア
 */
void switch_push_clear(void);

/*
 * PUSHスイッチコールバック関数設定
 */
void setup_sw_func(intptr_t exinf);


/*
 * DIPSWの取出し
 */
uint_t switch_dip_sense(void);


extern void device_info_init(intptr_t exinf);

extern uint_t dipsw_value;

#ifdef __cplusplus
}
#endif

#endif

